﻿/**
* 
* Rule of Grid Layout
* 
* @author nutsu
* @version 0.5
* 
*/

package nutsu.display {

	import flash.geom.Point;
	
	public class GridLayout extends Object{
		
		//layout axis
		public static const HORIZONTAL:String = "horizontal";
		public static const VERTICAL:String   = "vertical";
		
		//layout direction
		public static const DIR_LR:String     = "LeftToRight";
		public static const DIR_RL:String     = "RightToLeft";
		public static const DIR_TB:String     = "TopToBottom";
		public static const DIR_BT:String     = "BottomToRight";
		
		//direction axis type
		private var _type:String;
		
		//horizontal direction
		private var _h_dir:String;
		
		//vertical direction
		private var _v_dir:String;
		
		//numbers of unit when matrix layout
		private var _unit_num:int;
		
		//layout direction for point
		private var xd:int;
		private var yd:int;
		
		/**
		* Constructor
		* @param	type_
		* @param	unit_num
		* @param	h_dir
		* @param	v_dir
		*/
		public function GridLayout( type_:String, unit_num:int=0, h_dir:String="LeftToRight", v_dir:String="TopToBottom" ){
			_type = type_;
			_h_dir = h_dir;
			_v_dir = v_dir;
			_unit_num = unit_num;
			
			xd = ( _h_dir==DIR_LR ) ? 1 : -1;
			yd = ( _v_dir==DIR_TB ) ? 1 : -1;
		}
		
		
		public function get type():String{
			return _type;
		}
		public function get hrizontalDir():String{
			return _h_dir;
		}
		public function get verticalDir():String{
			return _v_dir;
		}
		public function get unitNumber():int{
			return _unit_num;
		}
		
		/**
		* Layout potistion by index
		* @param	index
		* @return	Point
		*/
		public function getLayoutPos( index:uint ):Point{
			var p1:int;
			var p2:int;
			if( _unit_num==0 ){
				p1 = index;
				p2 = 0;
			}else{
				p1 = index%_unit_num;
				p2 = (index-p1)/_unit_num;
			}
			if( _type==HORIZONTAL ){
				return new Point( p1*xd, p2*yd );
			}else{
				return new Point( p2*xd, p1*yd );
			}
		}
		
		public function getIndex( m:int, n:int ):int{
			if( _type==HORIZONTAL ){
				return n*_unit_num + m;
			}else{
				return m*_unit_num + n;
			}
		}
	}
}
